
#    This file is part of PyTrucoEngine.
#
#    PyTrucoEngine is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    PyTrucoEngine is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with PyTrucoEngine.  If not, see <http://www.gnu.org/licenses/>.

import random

class Deck():
    """Generic representation of a deck of playing cards"""

    def __init__(self, cards):
        """Initializes the deck"""
        self.original_deck = cards
        self.ingame_deck = cards

    def reinitialize(self):
        """Restores the ingame deck to its original state"""
        self.ingame_deck = self.original_deck

    def mix(self):
        """Randomizes the ingame deck"""
        deck = self.original_deck
        buffer_list = []
        while deck:
            choice = random.choice(deck)
            deck.remove(choice)
            buffer_list.append(choice)
        self.ingame_deck = buffer_list

    def deal_card(self):
        """Removes a card from the ingame deck and returns it"""
        return self.ingame_deck.pop()
